package rozdzial28;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.concurrent.Task;
import javafx.scene.Scene;
import javafx.scene.control.Button;
import javafx.scene.control.Label;
import javafx.scene.layout.HBox;
import javafx.scene.layout.VBox;
import javafx.stage.Stage;

import java.math.BigInteger;
import java.time.Duration;
import java.time.Instant;
import java.util.concurrent.ExecutionException;

public class Listing28_07 extends Application {
    private Label label;

    public static void main(String[] args) {
        Application.launch(args);
    }

    @Override
    public void start(Stage stage) {
        try {
            VBox vbox = new VBox();
            HBox hbox = new HBox();
            Scene scene = new Scene(vbox, 200, 200);
            label = new Label("Kliknij przycisk 'Zacznij'");
            Button start = new Button("Zacznij");
            //start.setOnAction(e -> task());
            start.setOnAction(event -> {
                try {
                    task();
                } catch (InterruptedException | ExecutionException e) {
                    e.printStackTrace();
                }
            });
            Button end = new Button("Zakończ");
            end.setOnAction(e -> stage.close());
            hbox.setSpacing(5);
            hbox.getChildren().addAll(start, end);
            vbox.setSpacing(150);
            vbox.getChildren().addAll(label, hbox);
            stage.setScene(scene);
            stage.show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void task() throws InterruptedException, ExecutionException {
        long a = 10000L;
        Task<BigInteger> task = new Task<>() {
            @Override
            protected BigInteger call() throws Exception {
                BigInteger sum = BigInteger.valueOf(0);
                BigInteger beflast = BigInteger.valueOf(0);
                BigInteger last = BigInteger.valueOf(1);
                for (long i = 1; i < a; i++) {
                    sum = beflast.add(last);
                    beflast = last;
                    last = sum;
                    final BigInteger psum = last;
                    Platform.runLater(() -> {
                        updateValue(psum);
                        label.setText("Liczę: " + getValue());
                    });
                }
                return sum;
            }
        };
        Thread backThread = new Thread(task);
        backThread.setDaemon(true);
        backThread.start();
        System.out.println("Start");
        Instant startTime = Instant.now();
        final BigInteger n = task.get();
        Instant endTime = Instant.now();
        long time = Duration.between(startTime, endTime).toMillis();
        System.out.println("Czas wykonania: " + time + (" ms"));
        System.out.println("fibo" + a + " = " + n);
        System.out.println("Koniec");
        Platform.runLater(() -> label.setText("Twoja liczba to " + String.valueOf(n)));
    }
}
